From f5c72266f7eedfaba8f0dc11cb91a6fba90fdfb1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 30 2020 20:05:10 +0000
Subject: [PATCH 768/2232] Make a module for the cxx-gen error type


---

diff --git a/gen/lib/src/error.rs b/gen/lib/src/error.rs
new file mode 100644
index 0000000..3cf1e62
--- /dev/null
+++ b/gen/lib/src/error.rs
@@ -0,0 +1,25 @@
+// We can expose more detail on the error as the need arises, but start with an
+// opaque error type for now.
+
+use std::error::Error as StdError;
+use std::fmt::{self, Debug, Display};
+
+pub struct Error(pub(crate) crate::gen::Error);
+
+impl Display for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        Display::fmt(&self.0, f)
+    }
+}
+
+impl Debug for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        Debug::fmt(&self.0, f)
+    }
+}
+
+impl StdError for Error {
+    fn source(&self) -> Option<&(dyn StdError + 'static)> {
+        self.0.source()
+    }
+}
diff --git a/gen/lib/src/lib.rs b/gen/lib/src/lib.rs
index 81962e1..bdeedfc 100644
--- a/gen/lib/src/lib.rs
+++ b/gen/lib/src/lib.rs
@@ -9,15 +9,13 @@
 
 #![allow(dead_code)]
 
+mod error;
 mod gen;
 mod syntax;
 
+pub use crate::error::Error;
 pub use crate::gen::{GeneratedCode, Opt};
 use proc_macro2::TokenStream;
-use std::error::Error as StdError;
-use std::fmt::{self, Debug, Display};
-
-pub struct Error(crate::gen::Error);
 
 /// Generate C++ bindings code from a Rust token stream. This should be a Rust
 /// token stream which somewhere contains a `#[cxx::bridge] mod {}`.
@@ -27,21 +25,3 @@ pub fn generate_header_and_cc(rust_source: TokenStream, opt: &Opt) -> Result<Gen
         .map_err(Error)?;
     gen::generate(syntax, opt).map_err(Error)
 }
-
-impl Display for Error {
-    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
-        Display::fmt(&self.0, f)
-    }
-}
-
-impl Debug for Error {
-    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
-        Debug::fmt(&self.0, f)
-    }
-}
-
-impl StdError for Error {
-    fn source(&self) -> Option<&(dyn StdError + 'static)> {
-        self.0.source()
-    }
-}

